#ifndef __PNPIMG
#define __PNPIMG

//
// quick and dirty wraper to pnglib
// au: vitas
//

/* 
 * Copyright (c) 2006, vitas@matfyz.cz
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *       
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include<png.h>

typedef unsigned char uch;

typedef struct t_img {
	png_uint_32 w, h, rb;
	int dep, col_type;
	uch * data;
	uch ** rows;

} t_img;

t_img* img_load(char *file_name);
t_img* img_new();
t_img* img_create(int w, int h, int dep);

void img_free(t_img*img);
void img_save(t_img *img, char *filename);

/* cpy img1 to img2 at position x, y */
void img_cpy(t_img *img1, t_img *img2, int x, int y);

/* avg each (dx x dy) pixels to one pixel */
void img_avg(t_img *img, int dx, int dy);

/* distance of img1 from subimage of img2 (starts at x1,y1 and size  wxh) */
double img_dist(t_img *img1,  t_img *img2, int x1, int y1, int w, int h);

#define IMG_GETPIXEL_R(i, x,y) ((i)->rows[(y)][(x)*3+0])
#define IMG_GETPIXEL_G(i, x,y) ((i)->rows[(y)][(x)*3+1])
#define IMG_GETPIXEL_B(i, x,y) ((i)->rows[(y)][(x)*3+2])

#define IMG_PUTPIXEL(i, x,y, r, g, b) { \
	((i)->rows[(y)][(x)*3+0]) = (r); \
	((i)->rows[(y)][(x)*3+1]) = (g); \
	((i)->rows[(y)][(x)*3+2]) = (b); }


#endif
